/// <reference types="node" />
import { EventEmitter } from "events";
import notifee from '@notifee/react-native';
import { RTCPeerConnection, RTCIceCandidate, RTCSessionDescription, RTCView, MediaStream, MediaStreamTrack, registerGlobals } from 'react-native-webrtc';
export { RTCPeerConnection, RTCIceCandidate, RTCSessionDescription, RTCView, MediaStream, MediaStreamTrack, notifee, registerGlobals };
export declare function multiply(a: number, b: number): Promise<number>;
export declare function add(a: number, b: number): Promise<number>;
export declare function sayname(name: string): Promise<number>;
export declare function sayby(name: string, location: string, id: string, callBack: any): any;
export declare function obtainStream(): Promise<unknown>;
export declare class Client extends EventEmitter {
    ws: any;
    project_id: any;
    auth_token: any;
    ref_id: any;
    mc_token: any;
    session_uuid: any;
    peer_connection: any;
    call_from: any;
    local_stream: any;
    remote_stream: any;
    audio_paused: any;
    stream_paused: any;
    constructor(_Credentials: any);
    log(...args: any): void;
    /**
     * ping
     */
    sendPing(): void;
    /**
     * incomingCall
     */
    incomingCall(messageData: any): void;
    /**
     * AcceptCall
     */
    AcceptCall(): void;
    /**
     * DeclineCall
     */
    DeclineCall(): void;
    /**
     * Disconnect
     */
    Disconnect(): void;
    /**
     * PauseStream
     */
    PauseStream(): void;
    /**
     * ResumeStream
     */
    ResumeStream(): void;
    /**
     * switchCamera
     */
    SwitchCamera(): void;
    /**
     * MuteMic
     */
    MuteMic(): void;
    /**
     * UnmuteMic
     */
    UnmuteMic(): void;
    /**
     * GetStream
     */
    GetStream(params: any): Promise<unknown>;
    /**
     * endForegroundService
     */
    endForegroundService(): Promise<void>;
    /**
     * OneToOneCall
     */
    OneToOneCall(params: any): Promise<void>;
    /**
     * OnSessionCancel
     */
    OnSessionCancel(data: any): void;
    /**
     * Register
     */
    Register(auth_token: any, ref_id: any): void;
    CallResponse(messageData: any): void;
    AddCandidate(messageData: any): void;
    Connect(mediaServer: any): void;
}
